Vouchwell

io.github.Vouchwell由 GitHub 账号 Vouchwell 发布v0.8.0更新于 Oct 24, 2026

Read, verify and export a tamper-evident log of what an AI agent did. Read-only.

概览

AI 生成的概览

让助手通过策略网关运行其他 MCP 服务器,拦截或升级高风险工具调用,并生成可验证的凭据。

可以做什么
Vouchwell 代理 MCP 服务器,使每次工具调用在执行前先经过策略检查,每个决定——允许、阻止或升级给人工——都写入仅可追加的日志(R5、R7)。凭据采用 RFC 8785 规范形式的 Ed25519 签名、哈希链式衔接,并锚定在 RFC 6962 Merkle 日志中,参数以加盐承诺保存(R11、R12、R13、R15)。命令涵盖初始化日志与策略、查看、端到端验证、生成包含证明、导出给第三方的证据包,以及销毁载荷承诺(R17)。
适用场景
当智能体会花钱、发邮件或接触客户数据,而你需要执行前拦截决策,并需要第三方无需信任你的日志即可验证的证据时使用(R3、R4、R10)。适合希望在现有 MCP 服务器外加上策略执行与可审计性的团队,以及在 CI 中检测日志被篡改的场景(R18)。它不能替代覆盖智能体访问 API 的所有路径(R20)。
运行要求
作为本地 stdio 进程在桌面端运行,通过 npm 包 vouchwell 安装(npm install -g vouchwell,然后 vw init)(R5)。未声明认证、环境变量或请求头。可选的 hub 功能(vw remote add、vw push、vw cosign)需要连接 hub(R17)。
安装前请注意
它只是代理其他 MCP 服务器,若代理还有未经过包装的路径访问同一 API,就不会留下凭据(R20)。其密码学实现尚未经过独立审查(R21)。策略可以阻止或升级操作,凭据中的参数以加盐承诺形式保存;销毁盐值后这些载荷将永久无法打开(R15、R16)。vw push、vw cosign、vw shred 等命令会写入、外发或销毁数据(R17)。

安装

在 SourceWeft 中

  1. 打开 控制台中的 Vouchwell,将其添加到工作区。
  2. 为需要使用其工具的对话启用该服务。

Desktop only,通过 STDIO。 STDIO 服务会启动本地进程,因此需要 SourceWeft 桌面宿主。

其他 MCP 客户端

参照 仓库 中的启动说明。

README

vouchwell

Tamper-evident receipts for AI agent actions.

[CI] [License] [Dependencies]

Your agents spend money, send mail, and touch customer data. When something goes wrong, "our logs say it didn't" is not an answer — your logs are a text file you can edit.

Vouchwell makes every agent action policy-gated before it runs and cryptographically provable afterwards.

bash
npm install -g vouchwellvw init

Then wrap any MCP server — this is the whole integration:

jsonc
// .mcp.json — before{ "command": "npx", "args": ["-y", "@acme/mcp-crm"] }
// after{ "command": "vw", "args": ["proxy", "--namespace", "crm", "--", "npx", "-y", "@acme/mcp-crm"] }

Every tool call now hits your policy first, and every decision — allowed, blocked, or escalated to a human — lands in an append-only log an outside party can verify without trusting you.

BLOCKED  ops.query    destructive SQL from an agent is never permittedBLOCKED  ops.refund   budget refunds.daily would be exceeded: 45 already                      committed plus 90 proposed, against a cap of 100 per 24hBLOCKED  ops.query    arguments contain anthropic_key; policy forbids sending                      these to a tool

Why it is not just logging

Everyone is building agent observability — dashboards you have to take on faith. Vouchwell builds agent evidence: a record whose integrity a third party can check independently, using nothing but the file you hand them.

  • Signed — Ed25519 over an RFC 8785 canonical form.
  • Chained — each receipt commits to its predecessor's hash.
  • Tree-anchored — RFC 6962 Merkle log, the construction Certificate Transparency uses. Verified against the published CT reference vectors.
  • Sealed — arguments are salted commitments, not payloads. Destroy the salts and those payloads become permanently unopenable while every proof still verifies, so a GDPR erasure does not gut the audit trail.

Commands

vw init                    create a log, a starter policy, and a configvw proxy -- <cmd...>       wrap an MCP server; enforce policy, write receiptsvw log / vw stats / vw dash        inspectvw verify                  audit the local log end to endvw prove <seq>             inclusion proof for one receiptvw export / vw check       evidence bundle for a third party, and verify onevw remote add / vw push    connect to a hub and ship receiptsvw cosign                  have an independent witness counter-sign your rootvw shred --before <date>   destroy payload commitments, keep the audit trail

vw verify exits non-zero when a log has been altered — put it in CI.

What it does not do

  • It cannot prove an action it never saw. An agent with a second, unwrapped path to the same API leaves no receipt.
  • The cryptography has not been reviewed by anyone independent. It is pinned to published RFC 6962 and RFC 8032 vectors rather than only to itself, but that is not the same thing.

Full threat model: https://github.com/vouchwell/vouchwell/blob/main/docs/THREAT-MODEL.md

Part of Vouchwell

PackageWhat it is
vouchwellThe vw CLI — start here
@vouchwell/coreReceipts, Merkle log, policy engine. Zero dependencies.
@vouchwell/proxyThe MCP proxy and the hub client
@vouchwell/serverThe multi-tenant hub
@vouchwell/dashboardLocal read-only dashboard

Full documentation: https://github.com/vouchwell/vouchwell

Apache-2.0. The format, the verifier and the CLI are open and stay open: evidence you cannot verify without a vendor's permission is not evidence.

来源:packages/cli/README.md,提交 ec9d07b

工具

0
SourceWeft 尚未在沙箱中启动过该软件包,因此其工具未知。

版本历史

1
  1. v0.8.0最新Oct 14, 2026

评分

已满足适用检查项的 40%

该评分衡量此收录条目的完整程度,依据注册中心条目、端点与公开来源计算得出。它不是对服务器本身的评价,也不表示服务器安全或当前可用:可连通性是带日期的检查结果,评分也不包含安装量或用户评价。

  • 近 30 天内可连通25 分

    请保持端点能够响应 MCP 握手;SourceWeft 每 30 天探测一次。

  • 已声明认证方式10 分

    请在注册中心条目中声明凭据请求头,或保持端点能够响应探测,以便判定其认证方式。

  • 已列出工具15 分

    请让服务器在无凭据时响应 tools/list,或发布可在沙箱中无凭据启动的软件包。

  • 描述必需15 分
  • 图标10 分
  • 文档15 分
  • 许可证10 分

    请在仓库或注册中心条目中声明许可证。